<?php

namespace App\Repositories;

use App\Models\Kredit;

class KreditRepository
{

    protected $kredit;

    public function __construct(Kredit $kredit)
    {
        $this->kredit = $kredit;
    }

    public function getAll()
    {
        return $this->kredit->all();
    }

    public function findById(int $id)
    {
        return $this->kredit->find($id);
    }

    public function findByRekening(string $rekening)
    {
        return $this->kredit->where('rekening', $rekening)->first();
    }

    public function create(array $data): Kredit
    {
        return $this->kredit->create($data);
    }

    public function update(int $id, array $data): ?Kredit
    {
        $kredit = $this->findById($id);
        if ($kredit) {
            $kredit->update($data);
        }
        return $kredit;
    }

    public function delete($id)
    {
        $kredit = $this->findById($id);
        if ($kredit) {
            return $kredit->delete();
        }
        return false;
    }
}
